clear; 
disp(['get C codes']);
mex Ctransform.c; 
mex CMax1.c; 
mex CSum2.c; 
mex CMax2.c; 
mex CBackMax1.c

disp(['get model']);
load 'model';


disp(['get testing image']);
sub1 = 1; 
%fold = .6; imName = 'h1.jpg'; % a testing image
fold = .6; imName = 'h2.jpg'; % a testing image

im = imread(imName);
if size(im,3) == 3
    im = rgb2gray(im); % transform image from color to gray
end
J{1} = double(imresize(im, fold, 'nearest')); 
[sx1 sy1] = size(J{1}); 
Sx1 = zeros(1, 1)+sx1; Sy1 = zeros(1, 1)+sy1; 

disp(['get S1M1']);
getS1M1; 

disp(['get templates and get S2M2, please wait, I did not optimize']);
exten = h + sub*Lrange; 

cx = round((min(Mx)+max(Mx))/2); 
cy = round((min(My)+max(My))/2); 
for (i = 1:Totalsketch)
        Mx(i) = Mx(i)-cx; 
        My(i) = My(i)-cy; 
end

scales = (3:10)*.2;
Totalscale = length(scales);  
rotates = (-4:4); 
Totalrotate = length(rotates); 
squeezes = (6:14)*.1; 
Totalsqueeze = length(squeezes); 
Total = Totalscale*Totalrotate*Totalsqueeze; 
thatx = zeros(1, Total); 
thaty = zeros(1, Total); 
M2All = zeros(1, Total); 

MLrange = 12; 


showit = 0; 
maxs = -1e10; di = 0; 
for (si = 1:Totalscale)  
    for (o = 1:Totalrotate)
        for (qi = 1:Totalsqueeze)
          di = di + 1;          
          getS2M2;
          if (maxs<M2All(di))
            maxs = M2All(di); 
            maxsi = si; 
            maxo = o; 
            maxqi = qi; 
          end
        end
    end
end

showit = 1; 
o = maxo; 
si = maxsi; 
qi = maxqi; 
getS2M2;

disp(['The image size is ' num2str(sx1) ' times ' num2str(sy1)]);
disp(['The scale factor is ' num2str(scales(si))]);
disp(['The rotation is ' num2str(rotates(o)) ' times pi/15']);
disp(['The aspect factor is ' num2str(squeezes(qi))]);




